diff --git a/src/backend/access/heap/heapam.c b/src/backend/access/heap/heapam.c
new file mode 100644
index d10fb4e..c1e74c0
*** a/src/backend/access/heap/heapam.c
--- b/src/backend/access/heap/heapam.c
*************** log_heap_update(Relation reln, Buffer ol
*** 7583,7595 ****
  
  	/* Prepare WAL data for the old page */
  	xlrec.old_offnum = ItemPointerGetOffsetNumber(&oldtup->t_self);
! 	xlrec.old_xmax = HeapTupleHeaderGetRawXmax(oldtup->t_data);
  	xlrec.old_infobits_set = compute_infobits(oldtup->t_data->t_infomask,
  											  oldtup->t_data->t_infomask2);
  
  	/* Prepare WAL data for the new page */
  	xlrec.new_offnum = ItemPointerGetOffsetNumber(&newtup->t_self);
! 	xlrec.new_xmax = HeapTupleHeaderGetRawXmax(newtup->t_data);
  
  	bufflags = REGBUF_STANDARD;
  	if (init)
--- 8107,8119 ----
  
  	/* Prepare WAL data for the old page */
  	xlrec.old_offnum = ItemPointerGetOffsetNumber(&oldtup->t_self);
! 	xlrec.old_xmax = HeapTupleGetRawXmax(oldtup);
  	xlrec.old_infobits_set = compute_infobits(oldtup->t_data->t_infomask,
  											  oldtup->t_data->t_infomask2);
  
  	/* Prepare WAL data for the new page */
  	xlrec.new_offnum = ItemPointerGetOffsetNumber(&newtup->t_self);
! 	xlrec.new_xmax = HeapTupleGetRawXmax(newtup);
  
  	bufflags = REGBUF_STANDARD;
  	if (init)
*************** log_heap_update(Relation reln, Buffer ol
*** 7601,7606 ****
--- 8125,8134 ----
  	if (oldbuf != newbuf)
  		XLogRegisterBuffer(1, oldbuf, REGBUF_STANDARD);
  
+ 	if (info & XLOG_HEAP_INIT_PAGE)
+ 	{
+ 		XLogRegisterData((char *) &HeapPageGetSpecial(page)->pd_xid_base, sizeof(TransactionId));
+ 	}
  	XLogRegisterData((char *) &xlrec, SizeOfHeapUpdate);
  
  	/*
*************** heap_xlog_clean(XLogReaderState *record)
*** 7955,7961 ****
  		heap_page_prune_execute(buffer,
  								redirected, nredirected,
  								nowdead, ndead,
! 								nowunused, nunused);
  
  		freespace = PageGetHeapFreeSpace(page); /* needed to update FSM below */
  
--- 8483,8490 ----
  		heap_page_prune_execute(buffer,
  								redirected, nredirected,
  								nowdead, ndead,
! 								nowunused, nunused,
! 								true);
  
  		freespace = PageGetHeapFreeSpace(page); /* needed to update FSM below */
  
*************** heap_xlog_freeze_page(XLogReaderState *r
*** 8146,8152 ****
  			lp = PageGetItemId(page, xlrec_tp->offset); /* offsets are one-based */
  			tuple = (HeapTupleHeader) PageGetItem(page, lp);
  
! 			heap_execute_freeze_tuple(tuple, xlrec_tp);
  		}
  
  		PageSetLSN(page, lsn);
--- 8675,8681 ----
  			lp = PageGetItemId(page, xlrec_tp->offset); /* offsets are one-based */
  			tuple = (HeapTupleHeader) PageGetItem(page, lp);
  
! 			heap_execute_freeze_tuple_page(page, tuple, xlrec_tp);
  		}
  
  		PageSetLSN(page, lsn);
*************** heap_xlog_delete(XLogReaderState *record
*** 8233,8241 ****
  		fix_infomask_from_infobits(xlrec->infobits_set,
  								   &htup->t_infomask, &htup->t_infomask2);
  		if (!(xlrec->flags & XLH_DELETE_IS_SUPER))
! 			HeapTupleHeaderSetXmax(htup, xlrec->xmax);
  		else
! 			HeapTupleHeaderSetXmin(htup, InvalidTransactionId);
  		HeapTupleHeaderSetCmax(htup, FirstCommandId, false);
  
  		/* Mark the page as a candidate for pruning */
--- 8762,8770 ----
  		fix_infomask_from_infobits(xlrec->infobits_set,
  								   &htup->t_infomask, &htup->t_infomask2);
  		if (!(xlrec->flags & XLH_DELETE_IS_SUPER))
! 			HeapTupleHeaderSetXmax(page, htup, xlrec->xmax);
  		else
! 			HeapTupleHeaderSetXmin(page, htup, InvalidTransactionId);
  		HeapTupleHeaderSetCmax(htup, FirstCommandId, false);
  
  		/* Mark the page as a candidate for pruning */
*************** static void
*** 8257,8263 ****
  heap_xlog_insert(XLogReaderState *record)
  {
  	XLogRecPtr	lsn = record->EndRecPtr;
! 	xl_heap_insert *xlrec = (xl_heap_insert *) XLogRecGetData(record);
  	Buffer		buffer;
  	Page		page;
  	union
--- 8786,8792 ----
  heap_xlog_insert(XLogReaderState *record)
  {
  	XLogRecPtr	lsn = record->EndRecPtr;
! 	xl_heap_insert *xlrec;
  	Buffer		buffer;
  	Page		page;
  	union
*************** heap_xlog_insert(XLogReaderState *record
*** 8273,8278 ****
--- 8802,8819 ----
  	BlockNumber blkno;
  	ItemPointerData target_tid;
  	XLogRedoAction action;
+ 	bool		isinit = (XLogRecGetInfo(record) & XLOG_HEAP_INIT_PAGE) != 0;
+ 	TransactionId pd_xid_base = InvalidTransactionId;
+ 	Pointer		rec_data;
+ 
+ 	rec_data = (Pointer) XLogRecGetData(record);
+ 	if (isinit)
+ 	{
+ 		pd_xid_base = *((TransactionId *) rec_data);
+ 		rec_data += sizeof(TransactionId);
+ 	}
+ 
+ 	xlrec = (xl_heap_insert *) rec_data;
  
  	XLogRecGetBlockTag(record, 0, &target_node, NULL, &blkno);
  	ItemPointerSetBlockNumber(&target_tid, blkno);
*************** heap_xlog_insert(XLogReaderState *record
*** 8297,8307 ****
  	 * If we inserted the first and only tuple on the page, re-initialize the
  	 * page from scratch.
  	 */
! 	if (XLogRecGetInfo(record) & XLOG_HEAP_INIT_PAGE)
  	{
  		buffer = XLogInitBufferForRedo(record, 0);
  		page = BufferGetPage(buffer);
  		PageInit(page, BufferGetPageSize(buffer), sizeof(HeapPageSpecialData));
  		HeapPageGetSpecial(page)->pd_magic = HEAP_PAGE_MAGIC;
  		action = BLK_NEEDS_REDO;
  	}
--- 8838,8849 ----
  	 * If we inserted the first and only tuple on the page, re-initialize the
  	 * page from scratch.
  	 */
! 	if (isinit)
  	{
  		buffer = XLogInitBufferForRedo(record, 0);
  		page = BufferGetPage(buffer);
  		PageInit(page, BufferGetPageSize(buffer), sizeof(HeapPageSpecialData));
+ 		HeapPageGetSpecial(page)->pd_xid_base = pd_xid_base;
  		HeapPageGetSpecial(page)->pd_magic = HEAP_PAGE_MAGIC;
  		action = BLK_NEEDS_REDO;
  	}
*************** heap_xlog_insert(XLogReaderState *record
*** 8334,8340 ****
  		htup->t_infomask2 = xlhdr.t_infomask2;
  		htup->t_infomask = xlhdr.t_infomask;
  		htup->t_hoff = xlhdr.t_hoff;
! 		HeapTupleHeaderSetXmin(htup, XLogRecGetXid(record));
  		HeapTupleHeaderSetCmin(htup, FirstCommandId);
  		htup->t_ctid = target_tid;
  
--- 8876,8882 ----
  		htup->t_infomask2 = xlhdr.t_infomask2;
  		htup->t_infomask = xlhdr.t_infomask;
  		htup->t_hoff = xlhdr.t_hoff;
! 		HeapTupleHeaderSetXmin(page, htup, XLogRecGetXid(record));
  		HeapTupleHeaderSetCmin(htup, FirstCommandId);
  		htup->t_ctid = target_tid;
  
*************** heap_xlog_multi_insert(XLogReaderState *
*** 8390,8401 ****
  	int			i;
  	bool		isinit = (XLogRecGetInfo(record) & XLOG_HEAP_INIT_PAGE) != 0;
  	XLogRedoAction action;
  
  	/*
  	 * Insertion doesn't overwrite MVCC data, so no conflict processing is
  	 * required.
  	 */
! 	xlrec = (xl_heap_multi_insert *) XLogRecGetData(record);
  
  	XLogRecGetBlockTag(record, 0, &rnode, NULL, &blkno);
  
--- 8932,8951 ----
  	int			i;
  	bool		isinit = (XLogRecGetInfo(record) & XLOG_HEAP_INIT_PAGE) != 0;
  	XLogRedoAction action;
+ 	TransactionId pd_xid_base = InvalidTransactionId;
+ 	Pointer		rec_data;
  
  	/*
  	 * Insertion doesn't overwrite MVCC data, so no conflict processing is
  	 * required.
  	 */
! 	rec_data = (Pointer) XLogRecGetData(record);
! 	if (isinit)
! 	{
! 		pd_xid_base = *((TransactionId *) rec_data);
! 		rec_data += sizeof(TransactionId);
! 	}
! 	xlrec = (xl_heap_multi_insert *) rec_data;
  
  	XLogRecGetBlockTag(record, 0, &rnode, NULL, &blkno);
  
*************** heap_xlog_multi_insert(XLogReaderState *
*** 8419,8424 ****
--- 8969,8975 ----
  		buffer = XLogInitBufferForRedo(record, 0);
  		page = BufferGetPage(buffer);
  		PageInit(page, BufferGetPageSize(buffer), sizeof(HeapPageSpecialData));
+ 		HeapPageGetSpecial(page)->pd_xid_base = pd_xid_base;
  		HeapPageGetSpecial(page)->pd_magic = HEAP_PAGE_MAGIC;
  		action = BLK_NEEDS_REDO;
  	}
*************** heap_xlog_multi_insert(XLogReaderState *
*** 8470,8476 ****
  			htup->t_infomask2 = xlhdr->t_infomask2;
  			htup->t_infomask = xlhdr->t_infomask;
  			htup->t_hoff = xlhdr->t_hoff;
! 			HeapTupleHeaderSetXmin(htup, XLogRecGetXid(record));
  			HeapTupleHeaderSetCmin(htup, FirstCommandId);
  			ItemPointerSetBlockNumber(&htup->t_ctid, blkno);
  			ItemPointerSetOffsetNumber(&htup->t_ctid, offnum);
--- 9021,9027 ----
  			htup->t_infomask2 = xlhdr->t_infomask2;
  			htup->t_infomask = xlhdr->t_infomask;
  			htup->t_hoff = xlhdr->t_hoff;
! 			HeapTupleHeaderSetXmin(page, htup, XLogRecGetXid(record));
  			HeapTupleHeaderSetCmin(htup, FirstCommandId);
  			ItemPointerSetBlockNumber(&htup->t_ctid, blkno);
  			ItemPointerSetOffsetNumber(&htup->t_ctid, offnum);
*************** static void
*** 8514,8520 ****
  heap_xlog_update(XLogReaderState *record, bool hot_update)
  {
  	XLogRecPtr	lsn = record->EndRecPtr;
! 	xl_heap_update *xlrec = (xl_heap_update *) XLogRecGetData(record);
  	RelFileNode rnode;
  	BlockNumber oldblk;
  	BlockNumber newblk;
--- 9065,9071 ----
  heap_xlog_update(XLogReaderState *record, bool hot_update)
  {
  	XLogRecPtr	lsn = record->EndRecPtr;
! 	xl_heap_update *xlrec;
  	RelFileNode rnode;
  	BlockNumber oldblk;
  	BlockNumber newblk;
*************** heap_xlog_update(XLogReaderState *record
*** 8539,8544 ****
--- 9090,9107 ----
  	Size		freespace = 0;
  	XLogRedoAction oldaction;
  	XLogRedoAction newaction;
+ 	bool		isinit = (XLogRecGetInfo(record) & XLOG_HEAP_INIT_PAGE) != 0;
+ 	TransactionId pd_xid_base = InvalidTransactionId;
+ 	Pointer		rec_data;
+ 
+ 	rec_data = (Pointer) XLogRecGetData(record);
+ 	if (isinit)
+ 	{
+ 		pd_xid_base = *((TransactionId *) rec_data);
+ 		rec_data += sizeof(TransactionId);
+ 	}
+ 
+ 	xlrec = (xl_heap_update *) rec_data;
  
  	/* initialize to keep the compiler quiet */
  	oldtup.t_data = NULL;
*************** heap_xlog_update(XLogReaderState *record
*** 8597,8602 ****
--- 9160,9166 ----
  
  		oldtup.t_data = htup;
  		oldtup.t_len = ItemIdGetLength(lp);
+ 		HeapTupleCopyBaseFromPage(&oldtup, page);
  
  		htup->t_infomask &= ~(HEAP_XMAX_BITS | HEAP_MOVED);
  		htup->t_infomask2 &= ~HEAP_KEYS_UPDATED;
*************** heap_xlog_update(XLogReaderState *record
*** 8606,8612 ****
  			HeapTupleHeaderClearHotUpdated(htup);
  		fix_infomask_from_infobits(xlrec->old_infobits_set, &htup->t_infomask,
  								   &htup->t_infomask2);
! 		HeapTupleHeaderSetXmax(htup, xlrec->old_xmax);
  		HeapTupleHeaderSetCmax(htup, FirstCommandId, false);
  		/* Set forward chain link in t_ctid */
  		htup->t_ctid = newtid;
--- 9170,9176 ----
  			HeapTupleHeaderClearHotUpdated(htup);
  		fix_infomask_from_infobits(xlrec->old_infobits_set, &htup->t_infomask,
  								   &htup->t_infomask2);
! 		HeapTupleHeaderSetXmax(page, htup, xlrec->old_xmax);
  		HeapTupleHeaderSetCmax(htup, FirstCommandId, false);
  		/* Set forward chain link in t_ctid */
  		htup->t_ctid = newtid;
*************** heap_xlog_update(XLogReaderState *record
*** 8629,8639 ****
  		nbuffer = obuffer;
  		newaction = oldaction;
  	}
! 	else if (XLogRecGetInfo(record) & XLOG_HEAP_INIT_PAGE)
  	{
  		nbuffer = XLogInitBufferForRedo(record, 0);
  		page = (Page) BufferGetPage(nbuffer);
  		PageInit(page, BufferGetPageSize(nbuffer), sizeof(HeapPageSpecialData));
  		HeapPageGetSpecial(page)->pd_magic = HEAP_PAGE_MAGIC;
  		newaction = BLK_NEEDS_REDO;
  	}
--- 9193,9204 ----
  		nbuffer = obuffer;
  		newaction = oldaction;
  	}
! 	else if (isinit)
  	{
  		nbuffer = XLogInitBufferForRedo(record, 0);
  		page = (Page) BufferGetPage(nbuffer);
  		PageInit(page, BufferGetPageSize(nbuffer), sizeof(HeapPageSpecialData));
+ 		HeapPageGetSpecial(page)->pd_xid_base = pd_xid_base;
  		HeapPageGetSpecial(page)->pd_magic = HEAP_PAGE_MAGIC;
  		newaction = BLK_NEEDS_REDO;
  	}
*************** heap_xlog_update(XLogReaderState *record
*** 8740,8748 ****
  		htup->t_infomask = xlhdr.t_infomask;
  		htup->t_hoff = xlhdr.t_hoff;
  
! 		HeapTupleHeaderSetXmin(htup, XLogRecGetXid(record));
  		HeapTupleHeaderSetCmin(htup, FirstCommandId);
! 		HeapTupleHeaderSetXmax(htup, xlrec->new_xmax);
  		/* Make sure there is no forward chain link in t_ctid */
  		htup->t_ctid = newtid;
  
--- 9305,9313 ----
  		htup->t_infomask = xlhdr.t_infomask;
  		htup->t_hoff = xlhdr.t_hoff;
  
! 		HeapTupleHeaderSetXmin(page, htup, XLogRecGetXid(record));
  		HeapTupleHeaderSetCmin(htup, FirstCommandId);
! 		HeapTupleHeaderSetXmax(page, htup, xlrec->new_xmax);
  		/* Make sure there is no forward chain link in t_ctid */
  		htup->t_ctid = newtid;
  
*************** heap_xlog_lock(XLogReaderState *record)
*** 8881,8887 ****
  						   BufferGetBlockNumber(buffer),
  						   offnum);
  		}
! 		HeapTupleHeaderSetXmax(htup, xlrec->locking_xid);
  		HeapTupleHeaderSetCmax(htup, FirstCommandId, false);
  		PageSetLSN(page, lsn);
  		MarkBufferDirty(buffer);
--- 9446,9452 ----
  						   BufferGetBlockNumber(buffer),
  						   offnum);
  		}
! 		HeapTupleHeaderSetXmax(page, htup, xlrec->locking_xid);
  		HeapTupleHeaderSetCmax(htup, FirstCommandId, false);
  		PageSetLSN(page, lsn);
  		MarkBufferDirty(buffer);
*************** heap_xlog_lock_updated(XLogReaderState *
*** 8941,8947 ****
  		htup->t_infomask2 &= ~HEAP_KEYS_UPDATED;
  		fix_infomask_from_infobits(xlrec->infobits_set, &htup->t_infomask,
  								   &htup->t_infomask2);
! 		HeapTupleHeaderSetXmax(htup, xlrec->xmax);
  
  		PageSetLSN(page, lsn);
  		MarkBufferDirty(buffer);
--- 9506,9512 ----
  		htup->t_infomask2 &= ~HEAP_KEYS_UPDATED;
  		fix_infomask_from_infobits(xlrec->infobits_set, &htup->t_infomask,
  								   &htup->t_infomask2);
! 		HeapTupleHeaderSetXmax(page, htup, xlrec->xmax);
  
  		PageSetLSN(page, lsn);
  		MarkBufferDirty(buffer);
*************** heap_xlog_inplace(XLogReaderState *recor
*** 8991,8996 ****
--- 9556,9586 ----
  		UnlockReleaseBuffer(buffer);
  }
  
+ static void
+ heap_xlog_base_shift(XLogReaderState *record)
+ {
+ 	XLogRecPtr	lsn = record->EndRecPtr;
+ 	xl_heap_base_shift *xlrec = (xl_heap_base_shift *) XLogRecGetData(record);
+ 	Buffer		buffer;
+ 	Page		page;
+ 	BlockNumber blkno;
+ 	RelFileNode target_node;
+ 
+ 	XLogRecGetBlockTag(record, 0, &target_node, NULL, &blkno);
+ 
+ 	if (XLogReadBufferForRedo(record, 0, &buffer) == BLK_NEEDS_REDO)
+ 	{
+ 		page = BufferGetPage(buffer);
+ 		heap_page_shift_base(InvalidBuffer, page, xlrec->multi, xlrec->delta);
+ 		PageSetLSN(page, lsn);
+ 		MarkBufferDirty(buffer);
+ 	}
+ 
+ 	if (BufferIsValid(buffer))
+ 		UnlockReleaseBuffer(buffer);
+ }
+ 
+ 
  void
  heap_redo(XLogReaderState *record)
  {
*************** heap_redo(XLogReaderState *record)
*** 9012,9017 ****
--- 9602,9610 ----
  		case XLOG_HEAP_UPDATE:
  			heap_xlog_update(record, false);
  			break;
+ 		case XLOG_HEAP_BASE_SHIFT:
+ 			heap_xlog_base_shift(record);
+ 			break;
  		case XLOG_HEAP_HOT_UPDATE:
  			heap_xlog_update(record, true);
  			break;
*************** heap_mask(char *pagedata, BlockNumber bl
*** 9123,9129 ****
  	mask_page_hint_bits(page);
  
  	/* Ignore prune_xid (it's like a hint-bit) */
! 	HeapPageGetSpecial(page)->pd_prune_xid = InvalidTransactionId;
  
  	mask_unused_space(page);
  
--- 9716,9722 ----
  	mask_page_hint_bits(page);
  
  	/* Ignore prune_xid (it's like a hint-bit) */
! 	HeapPageSetPruneXid(page, InvalidTransactionId);
  
  	mask_unused_space(page);
  
diff --git a/src/backend/access/heap/hio.c b/src/backend/access/heap/hio.c
new file mode 100644
index 6877182..147c288
*** a/src/backend/access/heap/hio.c
--- b/src/backend/access/heap/hio.c
*************** void
*** 36,42 ****
  RelationPutHeapTuple(Relation relation,
  					 Buffer buffer,
  					 HeapTuple tuple,
! 					 bool token)
  {
  	Page		pageHeader;
  	OffsetNumber offnum;
--- 36,43 ----
  RelationPutHeapTuple(Relation relation,
  					 Buffer buffer,
  					 HeapTuple tuple,
! 					 bool token,
! 					 TransactionId xid)
  {
  	Page		pageHeader;
  	OffsetNumber offnum;
*************** RelationPutHeapTuple(Relation relation,
*** 50,55 ****
--- 51,59 ----
  	/* Add the tuple to the page */
  	pageHeader = BufferGetPage(buffer);
  
+ 	/* FIXME */
+ 	tuple->t_data->t_choice.t_heap.t_xmin = NormalTransactionIdToShort(HeapPageGetSpecial(pageHeader)->pd_xid_base, xid);
+ 
  	offnum = PageAddItem(pageHeader, (Item) tuple->t_data,
  						 tuple->t_len, InvalidOffsetNumber, false, true);
  
*************** RelationPutHeapTuple(Relation relation,
*** 68,75 ****
  	{
  		ItemId		itemId = PageGetItemId(pageHeader, offnum);
  		Item		item = PageGetItem(pageHeader, itemId);
  
! 		((HeapTupleHeader) item)->t_ctid = tuple->t_self;
  	}
  }
  
--- 72,80 ----
  	{
  		ItemId		itemId = PageGetItemId(pageHeader, offnum);
  		Item		item = PageGetItem(pageHeader, itemId);
+ 		HeapTupleHeader	tup = (HeapTupleHeader) item;
  
! 		tup->t_ctid = tuple->t_self;
  	}
  }
  
*************** RelationAddExtraBlocks(Relation relation
*** 207,212 ****
--- 212,218 ----
  		LockBuffer(buffer, BUFFER_LOCK_EXCLUSIVE);
  		page = BufferGetPage(buffer);
  		PageInit(page, BufferGetPageSize(buffer), sizeof(HeapPageSpecialData));
+ 		HeapPageGetSpecial(page)->pd_xid_base = RecentXmin - FirstNormalTransactionId;
  		HeapPageGetSpecial(page)->pd_magic = HEAP_PAGE_MAGIC;
  		MarkBufferDirty(buffer);
  		blockNum = BufferGetBlockNumber(buffer);
*************** loop:
*** 592,597 ****
--- 598,604 ----
  			 RelationGetRelationName(relation));
  
  	PageInit(page, BufferGetPageSize(buffer), sizeof(HeapPageSpecialData));
+ 	HeapPageGetSpecial(page)->pd_xid_base = RecentXmin - FirstNormalTransactionId;
  	HeapPageGetSpecial(page)->pd_magic = HEAP_PAGE_MAGIC;
  
  	if (len > PageGetHeapFreeSpace(page))
diff --git a/src/backend/access/heap/pruneheap.c b/src/backend/access/heap/pruneheap.c
new file mode 100644
index 622aacd..b512be6
*** a/src/backend/access/heap/pruneheap.c
--- b/src/backend/access/heap/pruneheap.c
*************** heap_page_prune_opt(Relation relation, B
*** 153,159 ****
  																 * needed */
  
  			/* OK to prune */
! 			(void) heap_page_prune(relation, buffer, OldestXmin, true, &ignore);
  		}
  
  		/* And release buffer lock */
--- 153,159 ----
  																 * needed */
  
  			/* OK to prune */
! 			(void) heap_page_prune(relation, buffer, OldestXmin, true, &ignore, true);
  		}
  
  		/* And release buffer lock */
*************** heap_page_prune_opt(Relation relation, B
*** 180,186 ****
   */
  int
  heap_page_prune(Relation relation, Buffer buffer, TransactionId OldestXmin,
! 				bool report_stats, TransactionId *latestRemovedXid)
  {
  	int			ndeleted = 0;
  	Page		page = BufferGetPage(buffer);
--- 180,186 ----
   */
  int
  heap_page_prune(Relation relation, Buffer buffer, TransactionId OldestXmin,
! 				bool report_stats, TransactionId *latestRemovedXid, bool repairFragmentation)
  {
  	int			ndeleted = 0;
  	Page		page = BufferGetPage(buffer);
*************** heap_page_prune(Relation relation, Buffe
*** 240,252 ****
  		heap_page_prune_execute(buffer,
  								prstate.redirected, prstate.nredirected,
  								prstate.nowdead, prstate.ndead,
! 								prstate.nowunused, prstate.nunused);
  
  		/*
  		 * Update the page's pd_prune_xid field to either zero, or the lowest
  		 * XID of any soon-prunable tuple.
  		 */
! 		HeapPageGetSpecial(page)->pd_prune_xid = prstate.new_prune_xid;
  
  		/*
  		 * Also clear the "page is full" flag, since there's no point in
--- 240,253 ----
  		heap_page_prune_execute(buffer,
  								prstate.redirected, prstate.nredirected,
  								prstate.nowdead, prstate.ndead,
! 								prstate.nowunused, prstate.nunused,
! 								repairFragmentation);
  
  		/*
  		 * Update the page's pd_prune_xid field to either zero, or the lowest
  		 * XID of any soon-prunable tuple.
  		 */
! 		HeapPageSetPruneXid(page, prstate.new_prune_xid);
  
  		/*
  		 * Also clear the "page is full" flag, since there's no point in
*************** heap_page_prune(Relation relation, Buffe
*** 284,293 ****
  		 * point in repeating the prune/defrag process until something else
  		 * happens to the page.
  		 */
! 		if (HeapPageGetSpecial(page)->pd_prune_xid != prstate.new_prune_xid ||
  			PageIsFull(page))
  		{
! 			HeapPageGetSpecial(page)->pd_prune_xid = prstate.new_prune_xid;
  			PageClearFull(page);
  			MarkBufferDirtyHint(buffer, true);
  		}
--- 285,294 ----
  		 * point in repeating the prune/defrag process until something else
  		 * happens to the page.
  		 */
! 		if (HeapPageGetPruneXid(page) != prstate.new_prune_xid ||
  			PageIsFull(page))
  		{
! 			HeapPageSetPruneXid(page, prstate.new_prune_xid);
  			PageClearFull(page);
  			MarkBufferDirtyHint(buffer, true);
  		}
*************** heap_prune_chain(Relation relation, Buff
*** 369,374 ****
--- 370,376 ----
  	HeapTupleData tup;
  
  	tup.t_tableOid = RelationGetRelid(relation);
+ 	HeapTupleCopyBaseFromPage(&tup, dp);
  
  	rootlp = PageGetItemId(dp, rootoffnum);
  
*************** heap_prune_chain(Relation relation, Buff
*** 407,413 ****
  				== HEAPTUPLE_DEAD && !HeapTupleHeaderIsHotUpdated(htup))
  			{
  				heap_prune_record_unused(prstate, rootoffnum);
! 				HeapTupleHeaderAdvanceLatestRemovedXid(htup,
  												 &prstate->latestRemovedXid);
  				ndeleted++;
  			}
--- 409,415 ----
  				== HEAPTUPLE_DEAD && !HeapTupleHeaderIsHotUpdated(htup))
  			{
  				heap_prune_record_unused(prstate, rootoffnum);
! 				HeapTupleHeaderAdvanceLatestRemovedXid(&tup,
  												 &prstate->latestRemovedXid);
  				ndeleted++;
  			}
*************** heap_prune_chain(Relation relation, Buff
*** 468,480 ****
  
  		tup.t_data = htup;
  		tup.t_len = ItemIdGetLength(lp);
  		ItemPointerSet(&(tup.t_self), BufferGetBlockNumber(buffer), offnum);
  
  		/*
  		 * Check the tuple XMIN against prior XMAX, if any
  		 */
  		if (TransactionIdIsValid(priorXmax) &&
! 			!TransactionIdEquals(HeapTupleHeaderGetXmin(htup), priorXmax))
  			break;
  
  		/*
--- 470,483 ----
  
  		tup.t_data = htup;
  		tup.t_len = ItemIdGetLength(lp);
+ 		HeapTupleCopyBaseFromPage(&tup, dp);
  		ItemPointerSet(&(tup.t_self), BufferGetBlockNumber(buffer), offnum);
  
  		/*
  		 * Check the tuple XMIN against prior XMAX, if any
  		 */
  		if (TransactionIdIsValid(priorXmax) &&
! 			!TransactionIdEquals(HeapTupleGetXmin(&tup), priorXmax))
  			break;
  
  		/*
*************** heap_prune_chain(Relation relation, Buff
*** 501,507 ****
  				 * that the page is reconsidered for pruning in future.
  				 */
  				heap_prune_record_prunable(prstate,
! 										   HeapTupleHeaderGetUpdateXid(htup));
  				break;
  
  			case HEAPTUPLE_DELETE_IN_PROGRESS:
--- 504,510 ----
  				 * that the page is reconsidered for pruning in future.
  				 */
  				heap_prune_record_prunable(prstate,
! 										   HeapTupleGetUpdateXidAny(&tup));
  				break;
  
  			case HEAPTUPLE_DELETE_IN_PROGRESS:
*************** heap_prune_chain(Relation relation, Buff
*** 511,517 ****
  				 * that the page is reconsidered for pruning in future.
  				 */
  				heap_prune_record_prunable(prstate,
! 										   HeapTupleHeaderGetUpdateXid(htup));
  				break;
  
  			case HEAPTUPLE_LIVE:
--- 514,520 ----
  				 * that the page is reconsidered for pruning in future.
  				 */
  				heap_prune_record_prunable(prstate,
! 										   HeapTupleGetUpdateXidAny(&tup));
  				break;
  
  			case HEAPTUPLE_LIVE:
*************** heap_prune_chain(Relation relation, Buff
*** 540,546 ****
  		if (tupdead)
  		{
  			latestdead = offnum;
! 			HeapTupleHeaderAdvanceLatestRemovedXid(htup,
  												 &prstate->latestRemovedXid);
  		}
  		else if (!recent_dead)
--- 543,549 ----
  		if (tupdead)
  		{
  			latestdead = offnum;
! 			HeapTupleHeaderAdvanceLatestRemovedXid(&tup,
  												 &prstate->latestRemovedXid);
  		}
  		else if (!recent_dead)
*************** heap_prune_chain(Relation relation, Buff
*** 559,565 ****
  		Assert(ItemPointerGetBlockNumber(&htup->t_ctid) ==
  			   BufferGetBlockNumber(buffer));
  		offnum = ItemPointerGetOffsetNumber(&htup->t_ctid);
! 		priorXmax = HeapTupleHeaderGetUpdateXid(htup);
  	}
  
  	/*
--- 562,568 ----
  		Assert(ItemPointerGetBlockNumber(&htup->t_ctid) ==
  			   BufferGetBlockNumber(buffer));
  		offnum = ItemPointerGetOffsetNumber(&htup->t_ctid);
! 		priorXmax = HeapTupleGetUpdateXidAny(&tup);
  	}
  
  	/*
*************** void
*** 680,686 ****
  heap_page_prune_execute(Buffer buffer,
  						OffsetNumber *redirected, int nredirected,
  						OffsetNumber *nowdead, int ndead,
! 						OffsetNumber *nowunused, int nunused)
  {
  	Page		page = (Page) BufferGetPage(buffer);
  	OffsetNumber *offnum;
--- 683,690 ----
  heap_page_prune_execute(Buffer buffer,
  						OffsetNumber *redirected, int nredirected,
  						OffsetNumber *nowdead, int ndead,
! 						OffsetNumber *nowunused, int nunused,
! 						bool repairFragmentation)
  {
  	Page		page = (Page) BufferGetPage(buffer);
  	OffsetNumber *offnum;
*************** heap_page_prune_execute(Buffer buffer,
*** 721,727 ****
  	 * Finally, repair any fragmentation, and update the page's hint bit about
  	 * whether it has free pointers.
  	 */
! 	PageRepairFragmentation(page);
  }
  
  
--- 725,732 ----
  	 * Finally, repair any fragmentation, and update the page's hint bit about
  	 * whether it has free pointers.
  	 */
! 	if (repairFragmentation)
! 		PageRepairFragmentation(page);
  }
  
  
*************** heap_get_root_tuples(Page page, OffsetNu
*** 755,760 ****
--- 760,766 ----
  		HeapTupleHeader htup;
  		OffsetNumber nextoffnum;
  		TransactionId priorXmax;
+ 		HeapTupleData tup;
  
  		/* skip unused and dead items */
  		if (!ItemIdIsUsed(lp) || ItemIdIsDead(lp))
*************** heap_get_root_tuples(Page page, OffsetNu
*** 763,768 ****
--- 769,776 ----
  		if (ItemIdIsNormal(lp))
  		{
  			htup = (HeapTupleHeader) PageGetItem(page, lp);
+ 			tup.t_data = htup;
+ 			HeapTupleCopyBaseFromPage(&tup, page);
  
  			/*
  			 * Check if this tuple is part of a HOT-chain rooted at some other
*************** heap_get_root_tuples(Page page, OffsetNu
*** 784,790 ****
  
  			/* Set up to scan the HOT-chain */
  			nextoffnum = ItemPointerGetOffsetNumber(&htup->t_ctid);
! 			priorXmax = HeapTupleHeaderGetUpdateXid(htup);
  		}
  		else
  		{
--- 792,798 ----
  
  			/* Set up to scan the HOT-chain */
  			nextoffnum = ItemPointerGetOffsetNumber(&htup->t_ctid);
! 			priorXmax = HeapTupleGetUpdateXidAny(&tup);
  		}
  		else
  		{
*************** heap_get_root_tuples(Page page, OffsetNu
*** 812,820 ****
  				break;
  
  			htup = (HeapTupleHeader) PageGetItem(page, lp);
  
  			if (TransactionIdIsValid(priorXmax) &&
! 				!TransactionIdEquals(priorXmax, HeapTupleHeaderGetXmin(htup)))
  				break;
  
  			/* Remember the root line pointer for this item */
--- 820,830 ----
  				break;
  
  			htup = (HeapTupleHeader) PageGetItem(page, lp);
+ 			tup.t_data = htup;
+ 			HeapTupleCopyBaseFromPage(&tup, page);
  
  			if (TransactionIdIsValid(priorXmax) &&
! 				!TransactionIdEquals(priorXmax, HeapTupleGetXmin(&tup)))
  				break;
  
  			/* Remember the root line pointer for this item */
*************** heap_get_root_tuples(Page page, OffsetNu
*** 825,831 ****
  				break;
  
  			nextoffnum = ItemPointerGetOffsetNumber(&htup->t_ctid);
! 			priorXmax = HeapTupleHeaderGetUpdateXid(htup);
  		}
  	}
  }
--- 835,841 ----
  				break;
  
  			nextoffnum = ItemPointerGetOffsetNumber(&htup->t_ctid);
! 			priorXmax = HeapTupleGetUpdateXidAny(&tup);
  		}
  	}
  }
